/*
 * NAME.......: CW42NTK.CH
 * AIM........: NTKCore function translator for Clip-4-Win backward compatibility
 * DATE.......: 29.07.06 - 12/2011
 * AUTHOR(s)..: (c) Jn Dechereux - All Right Reserved
 */


#include "windows.ch"

#xtranslate DbgTrace( [<p,...>] )	=>
#xtranslate DbgTrace( [<p,...>] ),	=>	nil,


#translate _lasthwnd()                  =>   (  __NtkLasthWnd()         )


#translate A2BIN( [<list,...>] )                   =>   (  __NTKA2BIN(<list>)            )
#translate ABORTDOC( <list,...> )                  =>   (  NTK_ABORTDOC(<list>)          )
#translate ALERT( [<cMsg>] )                       =>   (  NTK_MsgBox( , <cMsg>, "Info!"))
#translate APPENDDIALOG( <list,...> )              =>   (  NTK_APPENDDIALOG(<list>)      )
#translate ARC( [<list,...>] )                     =>   (  NTK_ARC([<list>])             )
#translate BIN2A( [<list,...>] )                   =>   (  __NTKBIN2A(<list>)            )
#translate BITBLT( <list,...> )                    =>   (  NTK_BITBLT(<list>)            )
#translate BEGINPAINT( <list,...> )                =>   (  NTK_BEGINPAINT(<list>)        )
#translate BRINGWINDOWTOTOP( [<list,...>] )        =>   (  NTK_BRINGWNDTOTOP([<list>])   )
#translate C4W_AND( <list,...> )                   =>   (  NTK_AND(<list>)               )
#translate C4W_BIN2I( <list,...> )                 =>   (  BIN2I(<list>)                 )
#translate C4W_BIN2L( <list,...> )                 =>   (  BIN2L(<list>)                 )
#translate C4W_HIWORD( <list,...> )                =>   (  NTK_HIWORD(<list>)            )
#translate C4W_I2BIN( <list,...> )                 =>   (  I2BIN(<list>)                 )
#translate C4W_INT( <P1> )                         =>   (  INT(<P1>)                     )
#translate C4W_L2BIN( <list,...> )                 =>   (  L2BIN(<list>)                 )
#translate C4W_LOWORD( <list,...> )                =>   (  NTK_LOWORD(<list>)            )
#translate C4W_NOT( <list,...> )                   =>   (  NTK_NOT(<list>)               )
#translate C4W_OR( <list,...> )                    =>   (  NTK_OR(<list>)                )
#translate CALLDLL( [<list,...>] )                 =>   (  NTK_CALLDLL([<list>])         )
#translate CALLWINDOWPROC( <list,...> )            =>   (  NTK_CALLWINDOWPROC(<list>)    )
#translate CHECKDLGBUTTON( <list,...> )            =>   (  NTK_CHECKDLGBUTTON(<list>)    )
#translate CHOOSECOLOR( [<list,...>] )             =>   (  NTK_CHOOSECOLOR([<list>])     )
#translate CHOOSEFONT( [<list,...>] )              =>   (  NTK_CHOOSEFONT([<list>])      )
#translate CHORD( [<list,...>] )                   =>   (  NTK_CHORD([<list>])           )
#translate CLIENTTOSCREEN( <list,...> )            =>   (  NTK_CLIENTTOSCREEN(<list>)    )
#translate CREATECOMPATIBLEDC( [<list,...>] )      =>   (  NTK_CREATECOMPATIBLEDC([<list>])  )
#translate CREATEDIALOG( <list,...> )              =>   (  NTK_CREATEDIALOG(<list>)      )
#translate CREATEHATCHBRUSH( <list,...> )          =>   (  NTK_CREATEHATCHBRUSH(<list>)  )
#translate CREATEPEN( <list,...> )                 =>   (  NTK_CREATEPEN(<list>)         )
#translate CREATESOLIDBRUSH( <list,...> )          =>   (  NTK_CREATESOLIDBRUSH(<list>)  )
#translate CREATEWINDOW( <list,...>)               =>   (  NTK_CREATEWINDOW(<list>)      )
#translate CREATEWINDOWEX( <list,...>)             =>   (  NTK_CREATEWINDOWEX(<list>)    )
#translate DEFFRAMEPROC( <list,...> )              =>   (  NTK_DEFFRAMEPROC(<list>)      )
#translate DEFMDICHILDPROC( <list,...> )           =>   (  NTK_DEFMDICHILDPROC(<list>)   )
#translate DEFWINDOWPROC( <list,...> )             =>   (  NTK_DEFWNDPROC(<list>)        )
#translate DELETEDC( <list,...>)                   =>   (  NTK_DELETEDC(<list>)          )
#translate DELETEOBJECT( <list,...> )              =>   (  NTK_DELETEOBJECT(<list>)      )
#translate DESTROYWINDOW( <list,...>)              =>   (  NTK_DESTROYWINDOW(<list>)     )
#translate DIALOGBOX( <list,...>)                  =>   (  NTK_DIALOGBOX(<list>)         )
#translate DRAWFOCUSRECT( <list,...> )             =>   (  NTK_DRAWFOCUSRECT(<list>)     )
#translate DRAWTEXT( <list,...> )                  =>   (  NTK_DRAWTEXT(<list>)          )
#translate ENABLEWINDOW( <list,...> )              =>   (  NTK_ENABLEWINDOW(<list>)      )
#translate ENDDOC( <list,...> )                    =>   (  NTK_ENDDOC(<list>)            )
#translate ENDPAGE( <list,...> )                   =>   (  NTK_ENDPAGE(<list>)           )
#translate ENDDIALOG( <list,...>)                  =>   (  NTK_ENDDIALOG(<list>)         )
#translate ENDPAINT( <list,...> )                  =>   (  NTK_ENDPAINT(<list>)          )
#translate FILLRECT( <list,...> )                  =>   (  NTK_FILLRECT(<list>)          )
#translate FREELIBRARY( <list,...> )               =>   (  NTK_FREELIBRARY(<list>)       )
#translate GETCAPTURE( [<list,...>] )              =>   (  NTK_GETCAPTURE([<list>])      )
#translate GETCLIENTRECT( <list,...>)              =>   (  NTK_GETCLIENTRECT(<list>)     )
#translate GETDC(<list,...>)                       =>   (  NTK_GETDC(<list>)             )
#translate GETDESKTOPWINDOW([<list,...>])          =>   (  NTK_GETDESKTOPWINDOW([<list>]) )
#translate GETDEVICECAPS( <list,...>)              =>   (  NTK_GETDEVICECAPS(<list>)     )
#translate GETDIBRECT( <list,...>)                 =>   (  NTK_GETDIBRECT(<list>)        )
#translate GETDLGITMTEXT( <list,...> )             =>   (  NTK_GETDlGITEMTEXT(<list>)    )
#translate GETDLGITEM( <hWndDlg>,<nId> )           =>   (  NTK_GETDLGITEM(<hWndDlg>,<nId>) )
#translate GETFOCUS( [<list,...>] )                =>   (  NTK_GETFOCUS([<list>])        )
#translate GETOBJECT( [<list,...>] )               =>   (  NTK_GETOBJECT([<list>])       )
#translate GETOPENFILENAME( <list,...> )           =>   (  NTK_GETOPENFILENAME( <list> ) )
#translate GETMODULEHANDLE( <list,...> )           =>   (  NTK_GETMODULEHANDLE( <list> ) )
#translate GETMODULEFILENAME( [<list,...>] )       =>   (  NTK_GetModuleFileName([<list>]) )
#translate GETPARENT( [<list,...>] )               =>   (  NTK_GETPARENT([<list>])       )
#translate GETPOLYFILLMODE( [<list,...>] )         =>   (  NTK_GETPOLYFILLMODE([<list>]) )
#translate GETPRINTDC( [<list,...>] )              =>   (  NTK_GETPRINTDC([<list>])      )
#translate GETPROCADDRESS( [<list,...>] )          =>   (  NTK_GETPROCADDRESS([<list>])  )
#translate GETSAVEFILENAME( <list,...> )           =>   (  NTK_GETSAVEFILENAME( <list> ) )
#translate GETSTOCKOBJECT( <list,...> )            =>   (  NTK_GETSTOCKOBJECT(<list>)    )
#translate GETSYSCOLOR( [<list,...>] )             =>   (  NTK_GETSYSCOLOR([<list>])     )
#translate GETSYSTEMMETRICS( <list,...> )          =>   (  NTK_GETSYSTEMMETRICS(<list>)  )
#translate GETTEXTEXTENT( <list,...> )             =>   (  NTK_GETTEXTEXTENT(<list>)     )
#translate GETTEXTMETRICS( <list,...>)             =>   (  NTK_GETTEXTMETRICS(<list>)    )
#translate GETVEREX( <list,...> )                  =>   (  NTK_GETVERSIONEX(>list>)      )
#translate GETWINDOW( <list,...> )                 =>   (  NTK_GETWINDOW(<list>)         )
#translate GETWINDOWRECT( <list,...> )             =>   (  NTK_GETWINDOWRECT(<list>)     )
#translate GETWINDOWTEXT( <list,...> )             =>   (  NTK_GETWINDOWTEXT(<list>)     )
#translate GETTICKCOUNT()                          =>   (  NTK_GETTICKCOUNT()            )
#translate GETWINDOWLONG( [<list,...>] )           =>   (  NTK_GETWINDOWLONG([<list>])   )
#translate HIDECARET( <list,...> )                 =>   (  NTK_HIDECARET(<list>)         )
#translate INVALIDATERECT( <list,...> )            =>   (  NTK_INVALIDATERECT(<list>)    )
#translate INVERTRECT( <list,...> )                =>   (  NTK_INVERTRECT(<list>)        )
#translate ISDLGBUTTONCHECKED( <list,...> )        =>   (  NTK_ISDLGBUTTONCHECKED(<list>))
#translate ISWINDOW( <list,...> )                  =>   (  NTK_ISWINDOW(<list>)          )
#translate ISWINDOWENABLED( <list,...> )           =>   (  NTK_ISWINDOWENABLED(<list>)   )
#translate ISWINDOWVISIBLE( <list,...> )           =>   (  NTK_ISWINDOWVISIBLE(<list>)   )
#translate KILLTIMER( <list,...> )                 =>   (  NTK_KILLTIMER(<list>)         )
#translate LINETO( <list,...> )                    =>   (  NTK_LINETO(<list>)            )
#translate LOADACCELERATORS( [<list,...>] )        =>   (  NTK_LOADACCELERATORS([<list>]))
#translate LOADBITMAP( [<list,...>] )              =>   (  NTK_LOADBITMAP([<list>])      )
#translate LOADCURSOR( <list,...> )                =>   (  NTK_LOADCURSOR(<list>)        )
#translate LOADICON( <list,...>)                   =>   (  NTK_LOADICON(<list>)          )
#translate LOADLIBRARY( [<list,...>] )             =>   (  NTK_LOADLIBRARY([<list>])     )
#translate MESSAGEBEEP( [<P1>] )                   =>   (  NTK_MESSAGEBEEP([<P1>])       )
#translate MODALDIALOG( <list,...> )               =>   (  NTK_MODALDIALOG(<list>)       )
#translate MOVETO( <list,...> )                    =>   (  NTK_MOVETO(<list>)            )
#translate MOVEWINDOW( <list,...> )                =>   (  NTK_MOVEWINDOW(<list>)        )
#translate PEEKMESSAGE( <list,...>)                =>   (  NTK_PEEKMESSAGE(<list>)       )
#translate PIE( [<list,...>] )                     =>   (  NTK_PIE([<list>])             )
#translate POLYGON( [<list,...>] )                 =>   (  NTK_POLYGON([<list>])         )
#translate POLYLINE( [<list,...>] )                =>   (  NTK_POLYLINE([<list>])        )
#translate POSTMESSAGE( <list,...>)                =>   (  NTK_POSTMESSAGE(<list>)       )
#translate PRINTDLG( <list,...>)                   =>   (  NTK_PRINTDLG(<list>)          )
#translate READDIB( <list,...> )                   =>   (  NTK_READDIB(<list>)           )
#translate RELEASECAPTURE( [<list,...>] )          =>   (  NTK_RELEASECAPTURE([<list>])  )
#translate RECTANGLE( <list,...> )                 =>   (  NTK_RECTANGLE(<list>)         )

#translate REGISTERCLASS( <list,...> )             =>   (  NTK_REGISTERCLASS(<list>)     )
#translate REGISTERCLASSEX( <list,...> )           =>   (  NTK_REGISTERCLASSEX(<list>)   )
#translate SETWINDOWPOS( <list,...>)               =>   (  NTK_SETWINDOWPOS(<list>)      )


//jnd: not completly exact! #translate REGISTERCLASS( <list,...> )             =>   (  NTK_REGISTERCLASS(<list>)     )
//     here is the accurate syntax:
// #translate REGISTERCLASS( <nStyle>, <hInst>, <hIcon>, <hCursor>, <hBgBrush>,             ;
//                           <cClass>, <bAction>, <aWM>, <nType> ] ,                        ;
//                           <nClassExtra>, <nWndExtra>, <cMenu> )                          ;
//           =>                                                                             ;
//            NTK_REGISTERCLASSEX( <nStyle>, <hInst>, <hIcon>, <hCursor>, <hBgBrush>,       ;
//                                 <cClass>, <bAction>, <cMenu>, <nClassExtra>, <nWndExtra> )


#translate RELEASEDC( <list,...> )                 =>   (  NTK_RELEASEDC(<list>)         )
#translate RGB(<r>,<g>,<b>)                        =>   (  NTK_RGB(<r>,<g>,<b>)          )
#translate SCREENTOCLIENT( <list,...> )            =>   (  NTK_SCREENTOCLIENT(<list>)    )
#translate SELECTOBJECT( <list,...> )              =>   (  NTK_SELECTOBJECT(<list>)      )
#translate SELECTWINDOW( [<list,...>] )            =>   (  NTK_SELECTWINDOW([<list>])    )
#translate SENDDLGITEMMESSAGE( <list,...> )        =>   (  NTK_SENDDLGITEMMESSAGE        )
#translate SENDMESSAGE( <list,...> )               =>   (  NTK_SENDMESSAGE(<list>)       )
#translate SETCAPTURE( [<list,...>] )              =>   (  NTK_SETCAPTURE([<list>])      )
#translate SETACCELERATORS( [<list,...>] )         =>   (  NTK_SETACCELERATORS([<list>]) )
#translate SETBKCOLOR( <list,...> )                =>   (  NTK_SETBKCOLOR(<list>)        )
#translate SETBKMODE( <list,...>)                  =>   (  NTK_SETBKMODE(<list>)         )
#translate SETDLGITEM( <list,...> )                =>   (  NTK_SETDLGITEM(<list>)        )
#translate SETDLGITEMTEXT( <list,...> )            =>   (  NTK_SETDLGITEM(<list>)        )
#translate SETFOCUS( <list,...> )                  =>   (  NTK_SETFOCUS(<list>)          )
#translate SETHANDLECOUNT( <list,...> )            =>   (  NTK_SETHANDLECOUNT(<list>)    )
#translate SETPIXEL( <list,...> )                  =>   (  NTK_SETPIXEL(<list>)          )
#translate SETPOLYFILLMODE( [<list,...>] )         =>   (  NTK_SETPOLYFILLMODE([<list>]) )
#translate SETSCROLLPOS( <list,...> )              =>   (  NTK_SETSCROLLPOS(<list>)      )
#translate SETSCROLLRANGE( <list,...> )            =>   (  NTK_SETSCROLLRANGE(<list>)    )
#translate SETSYSCOLOR( [<list,...>] )             =>   (  NTK_SETSYSCOLOR([<list>])     )
#translate SETTEXTCOLOR( <list,...> )              =>   (  NTK_SETTEXTCOLOR(<list>)      )
#translate SETTIMER( <list,...> )                  =>   (  NTK_SETTIMER(<list>)          )
#translate SETWINDOWLONG( [<list,...>] )           =>   (  NTK_SETWINDOWLONG([<list>])   )
#translate SETWINDOWTEXT( <list,...> )             =>   (  NTK_SETWINDOWTEXT(<list>)     )
#translate SHOWDIB( <list,...> )                   =>   (  NTK_SHOWDIB(<list>)           )
#translate SHOWWINDOW( <list,...> )                =>   (  NTK_SHOWWINDOW(<list>)        )
#translate SIZEOFCSTRUCT( [<list,...>] )           =>   (  __NTKSIZEOFCSTRUCT(<list>)    )
#translate STRETCHDIBITS( <list,...> )             =>   (  NTK_STRETCHDIBITS(<list>)     )
#translate STARTDOC( <list,...> )                  =>   (  NTK_STARTDOC(<list>)          )
#translate STARTPAGE( <list,...> )                 =>   (  NTK_STARTPAGE(<list>)         )
#translate SUBCLASSWINDOW( <list,...> )            =>   (  NTK_SUBCLASSWINDOW(<list>)    )
#translate TEXTOUT( <list,...>)                    =>   (  NTK_TEXTOUT(<list>)           )
#translate UPDATEWINDOW( <list,...> )              =>   (  NTK_UPDATEWINDOW(<list>)        )
#translate UNREGISTERCLASS( <list,...> )           =>   (  NTK_UNREGISTERCLASS(<list>)   )
#translate VALIDATERECT( <list,...>)               =>   (  NTK_VALIDATERECT(<list>)      )
#translate WINEXEC( <list,...>)                    =>   (  NTK_WINEXEC(<list>)           )
#translate WINHELP( <list,...> )                   =>   (  NTK_WINHELP(<list>)           )



#translate MAXROW([<list,...>])                    =>   (  __NTKMAXROW([<list>])         )
#translate MAXCOL([<list,...>])                    =>   (  __NTKMAXCOL([<list>])         )
#translate SETPOS([<list,...>])                    =>   (  __NTKSETPOS([<list>])         )
#translate GETMENU([<hWnd>])                       =>   (  NTK_GETMENU([<hWnd>])         )
// rem by Ab #translate DESTROYMENU([<list,...>])               =>   (  NTK_DESTROYMENU([<list>])     ) // Seems to cause a name conflict with the :Destroy() method of some NTK OO classes
#translate DESTROYMENU(<list,...>])                =>   (  NTK_DESTROYMENU(<list>)       ) // Ab's suggestion 1
// #translate DESTROYMENU(hWnd)                    =>   (  NTK_DESTROYMENU(hWnd)         ) // Ab's suggestion 2
#translate CREATEMENU()                            =>   (  NtkCreateMenu()               )
#translate CREATEPOPUPMENU()                       =>   (  NtkCreatePopupMenu()          )
#translate APPENDMENU([<list,...>])                =>   (  NtkAppendMenu([<list>])       )
#translate SETMENU([<list,...>])                   =>   (  NtkSetMenu([<list>])          )
#translate TRACKPOPUPMENU([<list,...>])            =>   (  NtkTrackPopupMenu([<list>])   )
#translate MOUSECOL([<list,...>])                  =>   (  NTK_MOUSECOL([<list>])        )
#translate MOUSEROW([<list,...>])                  =>   (  NTK_MOUSEROW([<list>])        )
#translate MOUSEX([<list,...>])                    =>   (  NTK_MOUSEX([<list>])          )
#translate MOUSEY([<list,...>])                    =>   (  NTK_MOUSEY([<list>])          )
#translate WINSETUP([<list,...>])                  =>   (  NtkC4wWinSetup([<list>])      )
#translate WNDSETUP([<list,...>])                  =>   (  NtkC4wWndSetup([<list>])      )

//#translate QUIT => ( NTK_WINQUIT() )





// ---- Std Message managment functions
#translate ISDIALOGMESSAGE( [<list,...>] )         =>   (  NTK_ISDIALOGMESSAGE([<list>])  )
#translate DISPATCHMESSAGE( [<list,...>] )         =>   (  NTK_DISPATCHMESSAGE([<list>])  )
#translate GETMESSAGE( [<list,...>] )              =>   (  NTK_GETMESSAGE([<list>])       )
#translate POSTQUITMESSAGE( [<list,...>] )         =>   (  NTK_POSTQUITMESSAGE([<list>])  )
#translate TRANSLATEMESSAGE( [<list,...>] )        =>   (  NTK_TRANSLATEMESSAGE([<list>]) )
#translate TRANSLATEACCELERATOR( [<list,...>] )    =>   (  NTK_TRANSLATEACCELERATOR([<list>]) )
#translate TRANSLMDISYSACCEL( [<list,...>] )       =>   (  NTK_TRANSLATEMDISYSACCEL([<list>]) )


// ---- ClipBoard functions
#translate CloseClipboard([<list,...>])            =>   (  NTK_CloseClipboard([<list>])          )
#translate CountClipbFormats([<list,...>])         =>   (  NTK_CountClipbFormats([<list>])       )
#translate EmptyClipboard([<list,...>])            =>   (  NTK_EmptyClipboard([<list>])          )
#translate EnumClipbFormats([<list,...>])          =>   (  NTK_EnumClipbFormats([<list>])        )
#translate GetClipboardData([<list,...>])          =>   (  NTK_GetClipbData([<list>])            )
#translate GetClipbData([<list,...>])              =>   (  NTK_GetClipbData([<list>])            )
#translate GetClipbFormatName([<list,...>])        =>   (  NTK_GetClipbFormatName([<list>])      )
#translate GetClipbOwner([<list,...>])             =>   (  NTK_GetClipbOwner([<list>])           )
#translate GetClipbViewer([<list,...>])            =>   (  NTK_GetClipbViewer([<list>])          )
#translate IsClipbFormatAvailable([<list,...>])    =>   (  NTK_IsClipbFormatAvailable([<list>])  )
#translate OpenClipboard([<list,...>])             =>   (  NTK_OpenClipboard([<list>])           )
#translate RegClipbFormat([<list,...>])            =>   (  NTK_RegClipbFormat([<list>])          )
#translate SetClipbData([<list,...>])              =>   (  NTK_SetClipbData([<list>])            )
#translate SetClipboardData([<list,...>])          =>   (  NTK_SetClipbData([<list>])            )



// ---- C4W's event managment functions  - Source code in ..\NTKLIB\RADEX\rNTKC4W.prg
// #ifdef	WE_WANT_C4W2NTK_CHKEVENT
  #translate CHKEVENT([<list,...>])                  =>   (  NtkC4wCheckEvent([<list>]) )
// #endif	// WE_DONTWANT_C4W2NTK_CHKEVENT

#ifdef	WE_WANT_C4W2NTK_EVENTHANDLER
  #translate ADDHANDLER([<list,...>])                =>   (  NtkC4wAddHandler([<list>]) )
  #translate DELHANDLER([<list,...>])                =>   (  NtkC4wDelHandler([<list>]) )
  #translate HANDLEEVENT([<list,...>])               =>   (  NtkC4wHandleEvent([<list>]) )
#endif	// WE_WANT_C4W2NTK_EVENTHANDLER







// ---- C4W's misc functions
#translate C4W_AUTOCLOSE( <list,...> )             =>   (  NTK_MSGBOX( , "Proc "+PROCNAME()+" Line:"+STR(PROCLINE()), "This C4W function is not allowed in NTK." , MB_OK)  )
// #translate CTL3DAUTOSUBCLASS( <list,...> )         =>   (  NTK_MSGBOX( , "Proc "+PROCNAME()+" Line:"+STR(PROCLINE()), "This C4W function is not allowed in NTK." , MB_OK)  )
// #translate CTL3DREGISTER( <list,...> )             =>   (  NTK_MSGBOX( , "Proc "+PROCNAME()+" Line:"+STR(PROCLINE()), "This C4W function is not allowed in NTK." , MB_OK)  )
// #translate CTL3DUNREGISTER( <list,...> )           =>   (  NTK_MSGBOX( , "Proc "+PROCNAME()+" Line:"+STR(PROCLINE()), "This C4W function is not allowed in NTK." , MB_OK)  )
#translate DELETEMENU( <list,...> )                =>   (  NTK_MSGBOX( , "Proc "+PROCNAME()+" Line:"+STR(PROCLINE()), "This C4W function is not allowed in NTK." , MB_OK)  )
#translate ENABLEMENUITEM( <list,...> )            =>   (  NTK_MSGBOX( , "Proc "+PROCNAME()+" Line:"+STR(PROCLINE()), "This C4W function is not allowed in NTK." , MB_OK)  )
// #translate GETMENUITEMCOUNT( <aMenu> )             =>   (  NTK_MSGBOX( , "Proc "+PROCNAME()+" Line:"+STR(PROCLINE()), "This C4W function is not allowed in NTK." , MB_OK)  )
#translate ISDIALOGOK( <list,...> )                =>   (  NTK_MSGBOX( , "Proc "+PROCNAME()+" Line:"+STR(PROCLINE()), "This C4W function is not allowed in NTK." , MB_OK)  )
#translate NTXPOS( <list,...> )                    =>   (  NTK_MSGBOX( , "Proc "+PROCNAME()+" Line:"+STR(PROCLINE()), "This C4W function is not allowed in NTK." , MB_OK)  )
*#translate _GETNCMDSHOW( <list,...> )              =>   (  NTK_MSGBOX( , "Proc "+PROCNAME()+" Line:"+STR(PROCLINE()), "This C4W function is not allowed in NTK." , MB_OK)  )
*#translate _GETPREVINSTANCE( <list,...> )          =>   (  NTK_MSGBOX( , "Proc "+PROCNAME()+" Line:"+STR(PROCLINE()), "This C4W function is not allowed in NTK." , MB_OK)  )



// ---- C4W's WBROWSE commands & functions
#translate WBCOLUMN{ [<list,...>] }               =>    (  NtkColumn:Init([<list>])      )




// NTK  EVENT_* emutation from chkevent()
//       EVENT             NTK VALUE               C4W original value
#define	EVENT_NONE        0                    // -1
#define	EVENT_OTHER       0                    // 0		// probably treated like EVENT_NONE
#define	EVENT_KEY         WM_KEYDOWN           // 1		// keystroke
#define	EVENT_MENU        WM_COMMAND           // 2	   // menu item selected
//#define	EVENT_WINSEL	3
#define	EVENT_CLOSE       WM_CLOSE             //	5
//#define	EVENT_BUTTON	6
//#define	EVENT_SCROLLBAR	7
#define	EVENT_QUIT        WM_QUIT              //	9		// quitting the application (either you
	                              			               // can QUIT, or if you call ChkEvent()
			                                              	// again, it will QUIT for you)
//#define	EVENT_INC	10
#define	EVENT_DESTROY	   WM_DESTROY           // 11		// window being destroyed
#define	EVENT_WINMOVE	   WM_MOVE              // 12		// window moved
#define	EVENT_WINSIZE	   WM_SIZE              // 13		// window resized: see maxrow(),maxcol()
#define	EVENT_REDRAW	   WM_PAINT             // 14		// need to re-draw window
#define	EVENT_SETFOCUS	   WM_SETFOCUS          // 15		// window given focus
#define	EVENT_KILLFOCUS	WM_KILLFOCUS         // 16		// window losing focus
#define	EVENT_LCLICK	   WM_LBUTTONDOWN       // 17		// mouse left click: see MouseX(),MouseY()
#define	EVENT_RCLICK	   WM_RBUTTONDOWN       // 18		// mouse right click: see MouseX(),MouseY()
#define	EVENT_MCLICK	   WM_MBUTTONDOWN       // 19		// mouse middle click: see MouseX(),MouseY()
#define	EVENT_CONTROL	   WM_COMMAND           // 20		// notification from child control
                  					                        // e.g. buttons
#define	EVENT_ACCELKEY	   WM_COMMAND           // 21		// accelerator key
#define	EVENT_HSCROLL     WM_VSCROLL	         // 22		// msg from horiz scrollbar control
#define	EVENT_VSCROLL	   WM_HSCROLL           // 23		// msg from vert scrollbar control
#define	EVENT_LDBLCLK	   WM_LBUTTONDBLCLK     // 24		// left double click: see MouseX(),MouseY()
#define	EVENT_RDBLCLK	   WM_RBUTTONDBLCLK     // 25		// right double click: see MouseX(),MouseY()
#define	EVENT_MDBLCLK	   WM_MBUTTONDBLCLK     // 26		// middle double click: see MouseX(),MouseY()
#define	EVENT_TIMER	      WM_TIMER             // 27		// time-out event
#define	EVENT_LBTNUP	   WM_LBUTTONUP         // 28		// mouse left button up
#define	EVENT_RBTNUP	   WM_RBUTTONUP         // 29		// mouse right button up
#define	EVENT_MBTNUP	   WM_MBUTTONUP         // 30		// mouse middle button up

// events reserved for users: 1024-32767
#define	EVENT_USER	1024		// user-specific events start here






