
@echo off

cls

REM
REM  Program   : RR.BAT - based on MAKE.BAT
REM
REM  Launch      RR
REM  Aim       : Compile & Link batch file for applications composed of
REM              multiple PRG modules
REM  Date      : 08/07/2013 17:12:49
REM  Author(s) : Jn DECHEREUX, Reece Bevan
REM  Copyright : (c) 2005 - Jn DECHEREUX. Tous droits rservs/All Rights Reserved.
REM

set HB_INSTALL=C:\XHARBOUR
set WNTK_INSTALL=C:\WNTK4HRB


REM -------------------------------------------------------------------
REM --------------------       rc/res common name           -----------
REM -------------------------------------------------------------------

set RC_RES_FILE=ws32


REM -------------------------------------------------------------------
REM --------------------       COMPILATION PHASE            -----------
REM -------------------------------------------------------------------

set myerror=N
rem echo 1. myerror is %myerror%

REM -- We "call" the oneprg file so we return here, to this file, when oneprg is done

echo.
CALL ONEPRG menueasy
if %myerror% equ Y goto :exit1

echo.
CALL ONEPRG version
if %myerror% equ Y goto :exit1

echo.
CALL ONEPRG new
if %myerror% equ Y goto :exit1

echo.
CALL ONEPRG buy32
if %myerror% equ Y goto :exit1

echo.
CALL ONEPRG DoDbf32
if %myerror% equ Y goto :exit1

echo.
CALL ONEPRG OnePro32
if %myerror% equ Y goto :exit1

echo.
CALL ONEPRG Emerg32
if %myerror% equ Y goto :exit1

echo.
CALL ONEPRG OrdFun32
if %myerror% equ Y goto :exit1

echo.
CALL ONEPRG WbNew32
if %myerror% equ Y goto :exit1

echo.
CALL ONEPRG Procs32
if %myerror% equ Y goto :exit1

echo.
CALL ONEPRG Type7_32
if %myerror% equ Y goto :exit1

echo.
CALL ONEPRG WbNew32
if %myerror% equ Y goto :exit1

REM -------- Insert your other PRG's module here, like that...
rem
rem And so on...


REM -------------------------------------------------------------------
REM --------------------      RC COMPILATION PHASE          -----------
REM -------------------------------------------------------------------

echo // Compiling RC file (probably)
echo.

rem  IF EXIST %RC_RES_FILE%.rc  BRC32 -v -r  %RC_RES_FILE%.rc

if %errorlevel% equ 1 goto :exit1


REM -------------------------------------------------------------------
REM 
REM                         LINKING PHASE - 1           
REM 
REM               c0w32.obj is special and must come first      
REM 
REM -------------------------------------------------------------------

echo c0w32.obj      + > b32.bc


REM -------------------------------------------------------------------
REM 
REM                           LINKING PHASE - 2       
REM 
REM  The obj names must match the prg files called in oneprg,bat
REM 
REM  Main program (menu) must be first
REM 
REM -------------------------------------------------------------------

echo Menueasy.obj + >> b32.bc
echo new.obj      + >> b32.bc
echo buy32.obj    + >> b32.bc
echo DoDbf32.obj  + >> b32.bc
echo OnePro32     + >> b32.bc
echo Emerg32      + >> b32.bc
echo OrdFun32     + >> b32.bc
echo WbNew32      + >> b32.bc
echo Procs32      + >> b32.bc
echo Type7_32     + >> b32.bc

rem -- And last, with a comma...
echo version.obj, + >> b32.bc


REM -------------------------------------------------------------------
REM --------------------          SPECIFY EXE NAME          -----------
REM -------------------------------------------------------------------

rem +  Call batch file containing the name of the EXE file
CALL VERSION

echo.	
ECHO // WinScope version: %exename%.exe
echo.	

echo %exename%.exe, + >> b32.bc
echo %exename%.map, + >> b32.bc

REM -------------------------------------------------------------------
REM ------------- xHarbour Libraries here:
REM -------------------------------------------------------------------

echo %HB_INSTALL%\lib\rtl.lib + >> b32.bc
echo %HB_INSTALL%\lib\vm.lib + >> b32.bc
echo %HB_INSTALL%\lib\gtgui.lib + >> b32.bc
echo %HB_INSTALL%\lib\lang.lib + >> b32.bc
   rem echo %HB_INSTALL%\lib\codepage.lib + >> b32.bc
echo %HB_INSTALL%\lib\macro.lib + >> b32.bc
echo %HB_INSTALL%\lib\rdd.lib + >> b32.bc
echo %HB_INSTALL%\lib\dbfntx.lib + >> b32.bc
   REM no more needed since 0.99.51 echo %HB_INSTALL%\lib\dbfdbt.lib + >> b32.bc
echo %HB_INSTALL%\lib\dbfcdx.lib + >> b32.bc
echo %HB_INSTALL%\lib\dbffpt.lib + >> b32.bc
echo %HB_INSTALL%\lib\hbsix.lib  + >> b32.bc

echo %HB_INSTALL%\lib\common.lib + >> b32.bc
rem echo %HB_INSTALL%\lib\debug.lib + >> b32.bc
echo %HB_INSTALL%\lib\pp.lib + >> b32.bc
echo %HB_INSTALL%\lib\pcrepos.lib + >> b32.bc
   REM echo %HB_INSTALL%\lib\hbzip.lib  + >> b32.bc
rem echo %HB_INSTALL%\lib\libct.lib + >> b32.bc

REM -------------------------------------------------------------------
REM ------------- NTK Project Libraries here:
REM -------------------------------------------------------------------

echo %WNTK_INSTALL%\ntklib\ntkcore.lib  + >> b32.bc
   REM echo %WNTK_INSTALL%\ntklib\ntkcorex.lib  + >> b32.bc
echo %WNTK_INSTALL%\ntklib\ntkbrwse.lib + >> b32.bc
echo %WNTK_INSTALL%\ntklib\ntkclass.lib + >> b32.bc
echo %WNTK_INSTALL%\ntklib\ntkradex.lib + >> b32.bc

REM -------------------------------------------------------------------
REM ------------- Extra Libraries here: (IF ANY)
REM -------------------------------------------------------------------


REM -------------------------------------------------------------------
REM ------------- BCC Required Libraries here:
REM -------------------------------------------------------------------
echo cw32.lib + >> b32.bc



REM ------------- .RES incorporation from previouly .RC compilation
IF EXIST %RC_RES_FILE%.res GOTO :ADD_RES
   echo import32.lib >> b32.bc
   GOTO LINK

:ADD_RES
echo import32.lib,, %RC_RES_FILE%.res >> b32.bc

:LINK
ilink32 -Gn -Tpe -aa -t @b32.bc

echo // After link, error level is %errorlevel%

if %errorlevel% equ 1 goto :exit1


REM -------------------------------------------------------------------
REM --------------          CLEANING PHASE            -----------------
REM -------------------------------------------------------------------

rem del *.tds

del *.C
del *.obj
goto :exit99

:exit1
echo -- 
echo -- End of rr.bat
echo -- 
goto :end

:exit99
echo -- 
echo -- End of rr.bat, producing %exename%.exe
echo -- 

:end

