
// c line 403-- "TotObj3:Destroy( )" commented out

/*
	Public Functions
					Demand7
					Demand7b
					Test7a
					NewFC

					Bad7Msg
					CheckJan
					DemandMon
					FCrefresh
					NeverWeek
					ScYear3
					StopMsg
					WbTone

	10/02/2010

		Function Bad7Msg: Deleted old screen mockup

	12/2009

		Altered 'BadMonReason := "Function DoCust...' c line 331

	2009 Genie

		Function NewFc7: different lumps of weeks added to lead time
		between types 7 and 8. Was: "LeadSave += 4" - add 4 for BOTH
		type 7 and type 8

	Jan 2008

		Many changes in date logic

	Jan 2007

		Function ScYear3 was ScYear2, based on static function ScYear2()
		in scyear.prg. Routine was renamed to avoid confusion.

    RB 2005:
        FUNCTION ScYear2()
            Flag2     := '. Business date problem or monthly figures loaded early'
                                                  ^ ------ text added ----------^
---------------------------*/


    STATIC FromWhere
    STATIC BadMonReason := ''
    STATIC nCustMon
    STATIC FirstCall := .t.
    STATIC hDlgStat

    MEMVAR CuDate
    MEMVAR WeekInYear
    MEMVAR gDateAry
    MEMVAR  aProd, aFcast, aEdit, aPromEd // must be private for celledit
    MEMVAR aProjMon // PROJected MONth of delivery
    MEMVAR aTotPromo
    MEMVAR aNewMonth

    MEMVAR hDlgGets

    MEMVAR OKmonFC // shows if monthly forecast is ok
    MEMVAR  fLongDisp

    #define   CRLF                      Chr( 13 ) + Chr ( 10 ) // cr + lf
/*
    #include "scmonFin.ch" // hash-defines for scmonmar, scmonfin, celledit.prg

    #include "TVM2.CH" // tvm2 will : #include "WinScope.ch"

    #define WIN_WANT_ALL

    #include "windows.ch"

    #include "windlgs.ch"
*/

// rem by Ab    #include "ALL32.ch"

//--- from BrwImage.prg

		#include "windows.ch"
		#include "ntkacc.ch"
		#include "ntkbtn.ch"
		#include "ntkcctrl.ch"
		#include "ntkgdi.ch"
		#include "NtkImg.ch"
		#include "ntkmsg.ch"
		#include "ntkdlg.ch"
		#include "ntkmenus.ch"
		#include "ntkedget.ch"
		#include "ntkcmd.ch"
		#include "ntkshell.ch"
		#include "wNtk.ch"
		#include "wNtkKeys.ch"

		#include "Directry.ch"  // xHarbour

//--- end: from BrwImage.prg

		#include "c4w2ntk.ch"

    ///////// #include "scmonary.ch"
    #define   A_REF_MONTH {  "JAN", "FEB", "MAR", "APR", "MAY", "JUN",;
                             "JUL", "AUG", "SEP", "OCT", "NOV", "DEC" }

    #define A_REF_WEEK {     4,     4,     5,     4,     4,     5,;
                             4,     4,     5,     4,     5,     4}




FUNCTION Demand7main ( pFrom,     LocType ) // was Demand7
    //.............. ( FromWhere, LocType )

    /* Shows two monthly edit screens.  Returns an ary generated by
    function 'NewFc7.'  The ary contains sales for the next few
    months, as well as the weekly sales.  */

    LOCAL MyDemand  := 0
    // LOCAL LeadDays

    FromWhere := pFrom

    *DemandMsg( 'FromWhere'    + ass( FromWhere  ) +;
    *          " Lead days: " + ass( LeadDays   )  )

    *ProdDepth2 () // upsets the valid clauses and the gets

    *glbox( 'FUNCTION Demand7 FromWhere ' + ass( FromWhere ))

    /*

    The 'FromWhere/pFrom' ary has 2 elements, the first is numeric, the
    second is a string, eg:  { 1, 'from EditOneRec' }. This tells us what
    called BigCalc1 / Demand1 and hence this routine. (Function 'BigC3'
    is regarded as a request generator)

+----------+-------------------------+--------+----------------------+
| Program  | Routine                 | Number | First routine called |
+----------+-------------------------+--------+----------------------+
| Scemerg  | EditOneRec slow         | 1      | BigCalc1             |
| Scemerg  | EditOneRec fast         | 11     | BigCalc1             |
+----------+-------------------------+--------+----------------------+
| Scordfun | BigC3 and Mysales4      | 2      | BigC3 / BigCalc1     |
| Scordfun | BigC3 and valid clauses | 3      | BigC3 / BigCalc1     |
+----------+-------------------------+--------+----------------------+
| WbNew    | AllFactors              | was 3  | BigC3 / BigCalc1     |
|          |                         | now 6  |                      |
+----------+-------------------------+--------+----------------------+
| Scalgo   | Type_n_Wk               | 4      | Demand1              |
+----------+-------------------------+--------+----------------------+
| Scmonfin | NewFC from              | 6      | BigC3                |
|          | TestDead5               |        |                      |
|          | when editing cells      |        |                      |
+----------+-------------------------+--------+----------------------+
| Scselect | FindProds               | 7      | Demand1              |
| Scselect | FindProds               | 8      | BigCalc1             |
+----------+-------------------------+--------+----------------------+
| ScRevRp  | PrtFunc                 | 9      | BigCalc1             |
+----------+-------------------------+--------+----------------------+
| WbNew    | DoFactor1               | 10     | (this routine)       |
+----------+-------------------------+--------+----------------------+

    NOTE:
    Number 4 (Type_n_Wk) should not happen
    Number 5 not used
    */

    if valtype( FromWhere ) = "A"
        FromWhere := FromWhere[ 1 ]
    else
        FromWhere := 99 // should never happen
    endif

    fLongDisp := FromWhere + 10

    IF   1 == FromWhere ;  // fLongDisp is 11
   .or. 11 == FromWhere    // called by editonerec

            // we hope OKmonFC will change from false to true

            MyDemand := Demand7a ( 1, 'EditOneRec', LocType ) // '1' - no pop-ups

    ELSEIF 2 == FromWhere // fLongDisp is 12, '2 - mysales4'

            MyDemand := Demand7b ( 12, .t., LocType ) // '2' - show pop-ups: no privates

    ELSEIF 3 == FromWhere // fLongDisp is 13
            /*
            no pop-ups

            3 - cannot show glbox !!
            Called by VALIDs in 'MySales4',
                 'MyPaint' forcing get key strokes,
            --------------*/
            MyDemand  := NewFc7( LocType , FromWhere ) // '3'

    ELSEIF 4 == FromWhere // fLongDisp is 14
            //
            NeverWeek() // msg for week end - should not appear

    ELSEIF 5 == FromWhere // 2009 from AllFactors
            //
            MyDemand := Demand7b ( 12, .t., LocType )

    ELSEIF 6 == FromWhere // fLongDisp is 16
            //
            // 'NewFC' calling 'BigC3' then here

            ************** glbox( '6  from NewFC' )

            MyDemand  := NewFc7( LocType , FromWhere ) // '6'

    ELSEIF 7 == FromWhere .or. 8 == FromWhere

            // glbox( '7 or 8, FindProds' )

            MyDemand := Demand7a ( 7, 'findprods', LocType ) // 7 or 8

    ELSEIF 9 == FromWhere    // ScRevRp's PrtFunc is 9

            // glbox( '9 ScRevRp: PrtFunc ' )

            MyDemand := Demand7a ( 7, 'PrtFunc', LocType ) // 9

    ELSEIF 10 == FromWhere

            // glbox( '10 wbnew: dofactor1' )

            MyDemand := Demand7b(  2, .t., LocType ) // 10
              					// |
              					// 2=mon sumy, 3=mon edit

    ELSE  // ................fLongDisp is unknown

            glbox( ' Function Demand7 - "ELSE" should not happen !!!!!!!' )
    ENDIF

RETURN MyDemand // Sales for the next few months, as well as the weekly sales.




STATIC FUNCTION DemandMsg ( text )

    SetWindowText( hFrameWnd, text )

    WbTone()
RETURN nil


FUNCTION WbTone
    //
    //        pitch, duration in 1/18 sec
    // Tone(  500,   4   ) = 500 Hz for 4/18 sec

    Tone(  500,   1 ) // beep
    Tone(   15,   1 ) // beep
RETURN nil



FUNCTION Test7a( LocType,         pFrom )
    /* eg,     ( INPROD->fq_type, 90    )

    "pFrom", which is now not used, is 90 for scemerg, 91 for scselect,
    92 for screvrp

    Sets "OKmonFC" as true or false, returns the same value
    */

    Demand7a ( 0, 'for test7a', LocType ) // Sets "OKmonFC" as true or false.

RETURN OKmonFC



STATIC FUNCTION Demand7a( MyFrom, text,        LocType )
    //                    7,     'findprods',  LocType )
    //                    0,     'for test7a', LocType )
    /*
    Sets "OKmonFC" as true or false.

    Returns an array with 4 elements

    Uses transient private variables that only exist for a fraction of a second.
    When called by EditOneRec, don't display the browses.
    */

    Local MyDemand7

    if nil <> MyFrom
        //
        FromWhere := MyFrom
    endif

    fLongDisp := 11 // ...............was........... MyLon

    // privates as per function DemoDlg.........
    //
    PRIVATE aProd, aFcast, aEdit, aPromEd // must be private for celledit
    PRIVATE aMarPromEd,    aMarEdit       // must be private for celledit
    PRIVATE aMarGross                     // must be private for celledit
    PRIVATE aMarFcast := Array( 12 )      // must be private for celledit

    PRIVATE aProjMon
    PRIVATE aTotPromo
    PRIVATE aNewMonth := {}
    PRIVATE aNewSeas  := {}
    PRIVATE nGloRecord
    PRIVATE fContinue := 2

    *PRIVATE hDlgLess // mless handle


    PRIVATE fDoneBefore

    PRIVATE TextLen, OldGet
    PRIVATE hCellWnd, hDlgCell

    OKmonFC   :=   .f.              // assume the worst
    MyDemand7 := { -1, 0, "", .t. } // assume the worst

    // Glbox( 'Demand7a, MyFrom ' + ass(myfrom))

/*

Jan 2008

The date array could be nil, so test for it.

*/
    IF nil == gDateAry
		//
		Return MyDemand7 // with OKmonFC set false
    ENDIF

	//Glbox( '255 - gDateAry' + ass(gDateAry) )

    /* if gDateAry[ 4 ] is 2, type7/8 forecast no good for the
    entire product range.  The 'OKmonFC' flag applies to the current
    product.  */

    // nProblem and gDateAry[ 4 ] values: zero=ok, 1=mild problem, 2=severe
    //
    IF gDateAry[ 4 ] <= 1   // ok or mild problem
        //
        IF DoCust() /* Try to find global record in CUSTOMER table,
	        defined by owner category = T */
            //
            IF ScMonFin3 ( INPROD -> prodcode, 8, 0, "MS Sans Serif" )
                //
                OKmonFC   := .t. // success (only if not severe problem)

                MyDemand7 := NewFc7( LocType , FromWhere )
                /*
                2009 - MyDemand7 will be an array with 4 elements
                */
            ELSE
                BadMonReason := "Function Scmonfin3 returned false"
            ENDIF
        ELSE
			BadMonReason := "Function DoCust returned false: no monthly record" // changed 12/2009
        ENDIF
	ELSE
		IF 1 == Gdateary[4]
			//
			BadMonReason := "Gdateary indicates a Mild date problem (2 to 5 months late)"
		ELSE
			BadMonReason := "Gdateary indicates a Severe date problem (6 or more months late)"
    	ENDIF
    ENDIF

    //Tone(   15,   1 ) // beep

RETURN MyDemand7 // 2009 - MyDemand7 will be an array with 4 elements




FUNCTION Demand7b ( MyLon, fDoCalc, LocType )    // called by wbnew.prg
    /*
    Returns sales for the next few months, as well as the weekly sales.
    */
    LOCAL MyDemand := 0 // note default zero
    LOCAL z

    // glbox( 'STATIC FUNCTION Demand7b' )

    fLongDisp := MyLon

    IF ! DoCust () /* Try to find global record in CUSTOMER table,
    defined by owner category = T
    	*/
        RETURN MyDemand
    ENDIF

    IF TotObj3 <> NIL
//////////            TotObj3:Destroy( ) // destroy the browse
            TotObj3:Destroy() // destroy the browse
            TotObj3 := NIL
    ENDIF

    EnableWindow( GetDlgItem( hDlgGets, IDD_EMERG_2_40 ), .f. )
    EnableWindow( GetDlgItem( hDlgGets, IDD_EMERG_2_50 ), .f. )
        *
        ScMonFin3 ( INPROD -> prodcode, 8, 0, "MS Sans Serif" )
        *
    // above call to ScMonFin3 is modeless, so don't show the buttons
    // IDD_EMERG_2_40, IDD_EMERG_2_50


    if fDoCalc
        //
        MyDemand := NewFc7( LocType , FromWhere )
    endif

RETURN MyDemand // Sales for the next few months, as well as the weekly sales.



FUNCTION NewFC ( pOB ) // alter the weekly forecast on the big dialog
    /*
    Called when user edits the big monthly future browse
    */

    BigC3( nil,      hDlgGets, { 6, 'from NewFC' }, pOB )

    /*
    Was:   BigC3( MyDoLift, hDlgGets, { 6, 'from NewFC' }, pOB )
    Feb 2001:    'MyDoLift' now ignored.
    */
RETURN .T.


FUNCTION CheckJan () // called by scmenu
    //
    // Sets 'WeekInYear', eg, { 1, 28/12/2000 } or { 53, 28/12/2000 }

    /* We know the current business date and hence we know the year we
    are in and the date of the 1st of January.  The year is defined as
    starting on the Monday before 1 Jan, provided 1 Jan is a weekday,
    and this date is placed in local variable 'JanBeg2', which may
    contain, for example, 28 December of the previous year */

    LOCAL StartYear, JanBegins, Day, JanBeg2, Text
    LOCAL NewYear,   NewBegins, NewWeekIn,    NewBeg2, fSameWeek

    StartYear := DtoS( BusDate )       //  eg, "20010202"
    StartYear := Left( StartYear, 4 )  // "2001"
    JanBegins := "01/01/" + StartYear  // "01/01/2001"
    JanBegins := CtoD( JanBegins )     //  01/01/2001 as a date

	JanBeg2 := JanBegins + DaysToAdd (JanBegins) // Jan 2008 code

    WeekInYear := Array( 3 ) // was 2 ele's
    WeekInYear[ 1 ] := Date2Week( BusDate, JanBeg2 )//convert date to week no.
    WeekInYear[ 2 ] := JanBeg2

    /* May display for example......

        The current business date is 06/06/2004

		30/12/2003 is a Monday

        The current business date is in week 99 of the year
    */

    Text := 'The current business date is '+ass( busdate )
    Text += CR // blank line

    Text += CR + ass( JanBeg2 )+ ' is a '+CdoW( JanBeg2 )
    Text += CR // blank line

    Text += CR + 'The current business date is in week '+;
                  ass( WeekInYear[ 1 ] )+ ' of the year'

    //Glbox( text )

	/*
	Jan 2008 code. Check next year's 1 Jan
	*/
    NewYear   := Val( StartYear )  + 1 // 2002 numeric
    NewBegins := "01/01/" + Transform( NewYear, '9999' )
    NewBegins := CtoD( NewBegins )

	NewBeg2   := NewBegins + DaysToAdd (NewBegins)

	/* Are, say, 29/12/ of this year (BusDate) and 28/12/ of this year
	(NewBeg2) in the same week? This could occur if week 53 of the
	busdate year is also week 1 of next year*/

	fSameWeek := (BusDate >= NewBeg2)

	If fSameWeek
	//.or. WeekInYear[ 1 ] > 52 // bad idea
		//
		NewWeekIn := 1
	Else
		NewWeekIn := WeekInYear[ 1 ]
	Endif

	WeekInYear[ 3 ] := NewWeekIn // note, 1 or 53 say

    Text := 'The current business date is '+ass( busdate )
    Text += '. This is in week '+;
                  ass( NewWeekIn )+ ' of ' + ;
	              If(fSameWeek, 'next year', 'this year')

    Text += CR // blank line

    Text += CR + 'NEXT YEAR:'
    Text += CR // blank line

    Text += CR + ass( NewBegins ) + ' is a ' + CdoW( NewBegins )
    Text += CR // blank line

    Text += CR + cdow( NewBeg2 ) + ass( NewBeg2 )           +;
                ' is the start of the first week of the year'

    //Glbox( text )

RETURN nil



STATIC FUNCTION DaysToAdd (JanBegins)
	/*

	Input  - date of 1 Jan, eg, 01/01/1812
	Output - days to add

	*/
    LOCAL Day, ToAdd

    Day := DoW( JanBegins ) // eg 1=Sun, 7=Sat

	DO CASE
		CASE Day == 1
		/*
		1st Jan is a Sunday, the 1st Monday in the year is the next day
		*/
		ToAdd := 1
	CASE Day == 7
		/*
		1st Jan is a Saturday, the 1st Monday is 2 days later
		*/
		ToAdd := 2
	OTHERWISE
		/*
		1st Jan is between Monday and Friday. Mon: add zero, Fri: add -4
		since year starts 4 days earlier
		*/
		ToAdd := 2 - Day
	ENDCASE

RETURN ToAdd // eg -4



STATIC FUNCTION Date2Week( pDate, JanBeg2 )
    // convert given date to week number since initial given date.

    LOCAL nGap, nWeek

    nGap  :=  pDate  - JanBeg2 // ... days since 1st Monday, eg 28 Dec
    nWeek :=  INT(nGap/7) + 1  // ... weeks since then, plus one

RETURN nWeek



FUNCTION NeverWeek

    #define NEVERWEEK_TEXT                                          ;
    'ScType7 Line 503.'                                           + ;
     CRLF                                                         + ;
    'Possible End-of-week processing error.'                      + ;
     CRLF + CRLF                                                  + ;
    "Probably called by scalgo's function type_n_wk"              + ;
     CRLF + CRLF                                                  + ;
    'You should never see this message. Contact Logistics Development.'

    MaxMsg( NEVERWEEK_TEXT )
RETURN .t.



FUNCTION ScYear3()
/*

Was ScYear2(), based on static function ScYear2() in scyear.prg

FixBusDate() sets CuDate to CUSTDATE -> LDate or NIL

Called by scmenu.prg and scpromon.prg. No check on return value.

*/

    LOCAL nCustYear
    LOCAL nBusDiffMon
    LOCAL nBusYear, Text, z, WeekTotal, CustWeek, Flag1, nCustMonTot
    LOCAL WeeksDiff // typically between 1 and 4
    LOCAL nCustWkTot
    LOCAL Flag2,   NextCustMon, NextCustWeeks
    LOCAL nProblem, WeeksLate,   MenuText,   BusMon, nBusdWkTot
    LOCAL nTemp

    Text := ''

    if nil == CuDate

        gDateAry := NIL // bad last customer date, make nil
        RETURN .t.
    endif

    * Convert year '01' to '2001'
    nCustYear := MyYear( CuDate )                 //    '2001'
    nCustYear := Val   ( nCustYear )              // numeric 2001

    * Extract month string
    nCustMon := Upper( SubStr( CuDate, 2, 3 ) )  // eg 'Dec'
    nCustMon := AScan( A_REF_MONTH, nCustMon   ) // eg  12 numeric=load month
    CustWeek := 0

    for z := 1 to nCustMon
        //
        CustWeek += A_REF_WEEK [ z ] // eg, month=2 so week=8
    next

    if nCustmon < 12
        //
        NextCustMon := nCustMon + 1
    else
        NextCustMon := 1
    endif

    NextCustWeeks := A_REF_WEEK [ NextCustMon ]

    nCustWkTot := 52 * nCustYear + CustWeek         // about 104k (52 x 2k)
    //glbox( 'Function ScYear2: nCustWkTot  ' + ass( nCustWkTot ))

    nBusYear   := Year ( BusDate )
    nBusdWkTot := 52 * nBusYear  + WeekInYear[ 1 ]  // about 104k (52 x 2k)
    //glbox( 'Function ScYear2: nbusdWkTot  ' + ass( nbusdWkTot ))

    WeeksDiff  := nBusdWkTot - nCustWkTot   // typically between 1 and 4
    //glbox( 'Function ScYear2: WeeksDiff   ' + ass( WeeksDiff  ))

    nCustMonTot := 12 * nCustYear + nCustMon   // about  24k (12 x 2k)

    BusMon := WeekToMonth ( WeekInYear [ 1 ] )

    // glbox( 'Function ScYear2: BusMon   ' + ass( BusMon   ))

    nBusDiffMon := (12 * nBusYear) + BusMon - nCustMonTot
                // difference in months

    /* Data loaded one month ago is normal. Data loaded two months ago
    may be ok, but check the weeks.  A gap of 3 or more months is
    bad news.  */

    // nProblem and gDateAry[ 4 ] values: zero=ok, 1=mild problem, 2=severe
    //
    nProblem := 0 // was : if true, red text on screen and type7/8 no good

    WeeksLate := WeeksDiff - NextCustWeeks
    MenuText  := ''

    if WeeksDiff <= 0
        //
        Flag2     := '. Business date problem or monthly figures loaded early'
        // was:   := '. Business date problem ?'
        Text      += 'There may be a problem with the business date'
        //
        nProblem   :=  2 // severe
        MenuText  += 'This may be due to a problem with the business date'
        //
    elseif WeeksDiff >= 1 .and. WeeksDiff <= NextCustWeeks // eg, 1 to 5
        //
        Flag2     := '. Timely'
        Text      += 'Monthly loading appears ok'
        //
    else // gap is 2 or more months, lateness 1 month or more.
        //
        nTemp := nBusDiffMon - 1 // number of months late
        //
        if 1 == nTemp
            //
            Flag2     := '. One month late'
            Text      += 'It seems you are one '            +;
                         'month late loading the monthly data'
        else
            //
            Flag2     := '. ' + ass( nTemp ) + 'months late'
            Text      += 'It seems you are ' + ass( nTemp ) + ;
                         'months late loading the monthly data'
        endif
        //
        if nTemp <= 6  // up to 6 months late
            //
            nProblem   := 1 // mild problem
        else
            nProblem   := 2 // severe
        endif
        MenuText  += Text
    endif

    // glbox( text )

    Text  := '' // reset text

    if nBusDiffMon < 1
        //
        Flag1 :=  0
        Text += 'There may be a problem with the business date'
        //
    elseif 1 == nBusDiffMon // ok
        //
        Flag1 :=  1
        Text += 'Monthly loading appears ok'
        //
    elseif 2 == nBusDiffMon
        //
        if WeeksDiff < 2
            //
            Flag1 :=  2
            Text += 'NOTE: it seems you are a few days late '
            Text += 'loading your monthly figures'
        else
            Flag1 :=  3
            Text += 'NOTE: it seems you are a few weeks late '
            Text += 'loading your monthly figures'
        endif
    else
        Flag1 :=  4
        Text += 'NOTE: A gap of 3 or more months indicates you have '
        Text += 'not loaded the monthly data in a timely manner.'
    endif

    // glbox( text )

	         //  1       2            3      4        5         6         7
	gDateAry :={ BusMon, nBusDiffMon, Flag2, nProblem, MenuText, nCustMon, CustWeek }

	// nProblem is 1 for lateness up to 5 months, 2 for 6+ months late

RETURN .t.


STATIC FUNCTION WeekToMonth ( pWeek )

    /* Convert, say, week 10 (passed) to month 3. This is based on
    the monthly load months which can be 4 or 5 weeks each.  */

    LOCAL WeekTotal := 0, z, MyMon

    for z := 1 to 12
        //
        WeekTotal += A_REF_WEEK [ z ]
        //
        if WeekTotal >= pWeek // eg, total 8, this week is 6 so stop
            //
            exit
        endif
    next

/*
Jan 2008 - show stuff
*/

    //Glbox( '662: WeekTotal ' + ass( WeekTotal ) )
    //Glbox( '662: z'          + ass( z         ) )

    // allow for z being 13 due to week 53.
    MyMon   := min( z, 12 )
RETURN MyMon




STATIC FUNCTION NewFc7( LocType , FromWhere ) // was public
    /*

    2009 - 3rd and 4th elements now added.

    Returns { SalPerWeek, TotalSales, WeeksInMon, HisEdit  } for types 7
    and 8.

    Was : Returns { SalPerWeek, TotalSales } for types 7 and 8. Changed
    Feb 2001, to add together (and return) the sales for the next few
    months, as well as giving the weekly sales.  So, if we sell 50
    pieces per week, return value could be { 50, 1250 }

    Sequence of calling:
    Always:        0 EditOneRec - Test7a
                   1 EditOneRec - BigCalc1
                   2 MySales4 - init   (line 297)
                   3 MySales4 - valids (several) for paint
    and sometimes  3 MySales4 - user edits
    and sometimes  6 CellEdit - MonPost

    Both types:  lead-time-weeks start today.  Add 4 weeks for iot.

    Type 7:  Look at 1st (partial) month, a few whole months (months
    2 to whatever) and the last (partial) month.  See prg3.txt !!

    Type 8:  Look at 1st (partial) month, a few whole months (months
    2 to whatever) and the last (so-called partial) month.  BUT TREAT LAST
    MONTH AS A WHOLE MONTH.

    'LeadWeeks' is weeks left to process. 'LeadSave' is total lead weeks.
    */

    LOCAL z,           ProjMonths, LeadDays, nGap
    LOCAL SalPerWeek,  TotalSales
    LOCAL WeeksBefore, WeekInMon
    LOCAL WeeksAfter,  LeadWeeks, SalesMon1,  SalesInter, WeeksInter
    LOCAL MonthsInter, MonInYear, LeadSave,   Text        // WeeksFinal
    LOCAL SalesMon2,   FutMon,    MyIot,      TotWkInMon
    LOCAL YearSales,   WholeYears
    LOCAL DiffMon,     Mon2
    LOCAL MonLate,     WeeksInMon // 2009
    LOCAL HisEdit                 // 2009

    if FromWhere <> 3    // no glboxes for mode 3 (valids and user edits)
        //
        //////////// ProdDepth() // new.prg
    endif

    /* 1st month.  Loading may be late.  Element 'gDateAry[ 2 ]'
    should be one month, but may be 2 (or, rarely, 3+).  Suppose
    last load was in December and we are one month late, so gap is 2 mon  */

    DiffMon := gDateAry[ 2 ]                // eg, 2 mon gap, one mon late
    MonLate := gDateAry[ 2 ] - 1            // eg, 2 mon gap, one mon late
    Mon2    := Make12( MonLate + nCustMon ) // eg, 1 + 12 = 13 gives 1
    // Mon2 is one for Jan, when last load should have been.

    WeeksBefore := 0

    for z:= 1 to Mon2
        //
        WeeksBefore += A_REF_WEEK [ z ]
    next

    DemandMon( @LeadDays ) // call 'DemandMon' to set lead days

    // store whole weeks version of days. VNF wants us to round-up
    //
    LeadSave := WeeksFromDays( LeadDays )

    /* 2009 Genie: different lumps of weeks added to lead time between
    types 7 and 8. Was: "LeadSave += 4" - add 4 for BOTH type 7 and type
    8
    */
    if 7 == LocType

    	LeadSave += Inprod->iot // 1, 2 or 4 weeks
    else
    	LeadSave += 4
    endif

    /* We want to handle large lead weeks.
    */
    YearSales  := 0
    LeadWeeks  := LeadSave
    WholeYears := Int( (LeadWeeks - 1) / 52 )  // eg, int of 51/52 is zero
    LeadWeeks  -= 52 * WholeYears              // eg, 52 less 1*0  is 52 weeks

    if WholeYears > 0
        for z := 1 to 12
            YearSales += aProd[ z ] // add monthly sales
        next
        YearSales *= WholeYears // times number of years
    endif

    // what is current week in the month? (eg 3)
    WeekInMon  := WeekInYear[ 1 ] - WeeksBefore
            // eg 2 (Jan)         - 50 (Dec)  .....gives -48

    if WeekInMon < 0
        //
        WeekInMon += 52  // convert -48 to 4
    endif

    // total weeks in the month? (eg 4)
    TotWkInMon := A_REF_WEEK [ Make12( Mon2 + 1 ) ]

    WeeksAfter := TotWkInMon - WeekInMon + 1
          // 2 := 4          - 3         + 1

    WeeksAfter := Min( WeeksAfter, LeadWeeks ) // eg, reduce 2 to 1

	/*
	Jan 2008
	Problem with "SalesMon1 := aProd[Make12(1 + MonLate)]" ...etc.
	*/
	If aProd == NIL
		//
		MaxMsg('You should QUIT THE ORDER SCREEN as advised by the previous warning')

		RETURN { 0, 0, "", 0 } // <<<<<<<<<<<<<< STOP <<<<<<
		//
	ElseIf ValType(aProd) <> "A"
		//
		Glbox('sctype7 - 764 - aprod type ' + ValType(aProd) )
		//
	ElseIf len(aProd) <> 12
		//
		Glbox('sctype7 - 764 - aprod len ' + mystr(len(aprod)))
	Endif

	If MonLate < 1 .or. MonLate > 12
		//
		//Glbox('770 - MonLate ' + mystr(MonLate))
	Endif

    // sales for Feb...
    SalesMon1 := aProd[ Make12( 1 + MonLate ) ] * (WeeksAfter / TotWkInMon  )
    //.......... aProd[ Make12( DiffMon     ) ] * (WeeksAfter / TotWkInMon  )
              // 100                        *  1          / 4  gives 25 pieces

    // how many weeks after partial month ?
    // for type 7, subtract 2nd half of current month from lead time
    //
    **********if 7 == LocType
        //
        LeadWeeks -= WeeksAfter          // eg, 1 less 1 gives 0
        LeadWeeks := Max( 0, LeadWeeks ) // at least zero - make sure
    ***********endif

    SalesInter := 0 // sales for intermediate months
    WeeksInter := 0
    MonthsInter := 0

    for z := 1 to 12
        //
        MonInYear := Make12( Mon2 + z + 1 ) // March etc = 3 = Mon2(1) +z(1) + 1
        //
        Msg7b( ' z         ' + ass( z           ))
        Msg7b( ' 2nd  -- moninyear ' + ass( moninyear   ))

        // will adding 4 or 5 weeks take us beyond the lead time?

        if WeeksInter + A_REF_WEEK [ MonInYear ] > LeadWeeks
            //
            Msg7b( ' exiting' )
            exit
        endif

        // did not exit, so this month is ok, add the weeks and the sales
        //
        WeeksInter  += A_REF_WEEK [ MonInYear       ]
        SalesInter  += aProd      [ Make12( z + 1 ) ] // March onwards
        MonthsInter ++

        Msg7b( ' weeksintwer       ' + ass( weeksinter  ))
        Msg7b( ' salesintwer       ' + ass( salesinter  ))
        Msg7b( ' monthsintwer       ' + ass( monthsinter  ))
    next

    // WeeksInter is now 8, sales are those for 2 months, MonthsInter is 2

    LeadWeeks -= WeeksInter // eg, 10 less 8 gives 2, or maybe zero

    if LeadWeeks > 0

        // what is final month number ?
        //
        MonInYear  := Make12( Mon2     + 2 + MonthsInter )
        FutMon     := Make12( DiffMon  + 1 + MonthsInter )
        TotWkInMon := A_REF_WEEK [ MonInYear ]
        // WeeksFinal := TotWkInMon - LeadWeeks

        if 7 == LocType
            SalesMon2 := aProd[ FutMon ] * ( LeadWeeks / TotWkInMon )
        else
            SalesMon2 := aProd[ FutMon ] // full month
        endif
    else
        SalesMon2 := 0
    endif

    TotalSales := SalesMon1 + SalesInter + YearSales + SalesMon2
    SalPerWeek := TotalSales / LeadSave

	WeeksInMon := aNewMonth[ 1 ] // eg,
	HisEdit    := aFcast   [ 1 ] // 2009, month one may be edited

    /* If you want next message remove slash-stars */

    /*
        StopMsg( {                                           ;
        'nCustMon    ' + ass( nCustMon   )   ,    ;
        'Mon2        ' + ass( mon2       )   ,    ;
        'Wk loaded   ' + ass( WeeksBefore)   ,    ;
        'Week in mon ' + ass( Weekinmon  )   ,    ;
        'TotWkInMon  ' + ass( TotWkInMon )   ,    ;
        'Weeks after ' + ass( Weeksafter )   ,    ;
        'lead   after' + ass( leadweeks  )   ,    ;
        'lead save   ' + ass( leadsave   )   ,    ;
        'Year Sales  ' + ass( YearSales  )   ,    ;
        'salesmon1   ' + ass( salesmon1  )   ,    ;
        'SalesInter  ' + ass( SalesInter )   ,    ;
        'mon in year ' + ass( moninyear  )   ,    ;
        'FutMon      ' + ass( FutMon     )   ,    ;
        'SalesMon2   ' + ass( SalesMon2  )   ,    ;
        'total sales ' + ass( totalsales )   ,    ;
        'sal per week' + ass( salperweek )   ;
        }      )
    */
RETURN { SalPerWeek, TotalSales, WeeksInMon, HisEdit }




STATIC FUNCTION Msg7b( text )

    // Msg7Dlg( text )

    // Msg7( text )

RETURN nil




STATIC FUNCTION Msg7( text ) // uses static 'FromWhere'

    if FromWhere <> 3    // no glboxes for mode 3
        //
        MaxMsg( 'FW' + ass( FromWhere ) + space(1) + text )
    endif

RETURN nil



FUNCTION FCrefresh( )
    /*
    Sets a future month to YES
    Called by scordfun:mysales4 when editing leadtime
    */
	FCref2() // Sets a future month to YES

    IF nil <> TotObj3
        //
	    TotObj3:refreshAll() // re-display
    ENDIF
RETURN .t.



FUNCTION FCref2( )
    /*
    Sets a future month (in global array "aProjMon") to YES

    Called by scmonfin's DoFut3_order

    Old note: Function SwiFut() sets TotObj3 := DoFut3_order(...)
    */
    LOCAL ProjMonths, LeadDays

    ProjMonths := DemandMon( @LeadDays )

    *DemandMsg( 'ProjMonths ' + ass(ProjMonths) )

// rem by Ab    SET ProjMonths BETWEEN 1 AND 12

	/*
	2009 - was crashing at "AFill".
	Now make a new array
	*/
    aProjMon := Array(12)

    AFill( aProjMon, "" ) // was crashing

    aProjMon[ ProjMonths ] := "YES"

RETURN .t.



FUNCTION DemandMon( LeadDays )
    /*
    RETURNS an integer (1 to 12 ) for the element of the future arys
    when delivery is expected.

    PASSED VALUE of lead days is modified.

    This may be called to init order screen and projdlt[now] may be
    nil, so we call AnyLead if needed.
    */
    LOCAL ProjMonths, NewDate, z

    IF Editproj >= 0
        *
        LeadDays := Editproj
		z := 'A'
        *
	Elseif INPROD-> use_agreed
        *
	    LeadDays := DoPopLead()
		z := 'B'
	Else
	    LeadDays := AnyLead  ( .T.,    NIL           )
		z := 'C'
	Endif

    * DemandMsg( '1088 LeadDays ' + ass(LeadDays) + z )

    ProjMonths := DemandMon2 ( LeadDays )

RETURN ProjMonths






STATIC FUNCTION DemandMon2 ( pDays ) // convert days to months-from-now
    /*
    PASSED VALUE of days is modified.
    Passed days may be lead time or (lead time + inter order time)

    RETURNS an integer (1 to 12 ) for the element of the future arys
    when delivery is expected.

    First, generate an integer (0 to 11 ) to show the difference between
    the current month and the month of expected delivery.

    eg now = Jan =  1, delivery = Jan   =  1, integer =  1 - 1  =   0
       now = Jan =  1, delivery = March =  3, integer =  3 - 1  =   2
       now = Jan =  1, delivery = Dec   = 12, integer = 12 - 1  =  11
       now = Dec = 12, delivery = Jan   =  1, integer =  1 - 12 = -11 => 1

    Having calculated the difference, remember that Clipper arys start at
    one, so add one. Also, if user late in loading, add lateness.
    */
    LOCAL weeksgap, NewWeek, NewMon, OldMon, ProjMonths

    weeksgap := WeeksFromDays( pDays )

    NewWeek := WeekInYear[ 1 ] + weeksgap // may exceed 52, eg, 62

    NewWeek := MakeAny( NewWeek, 52 ) // week  10

    NewMon  := WeekToMonth( NewWeek ) // month  3

    OldMon  := gDateAry[ 1 ]          // month 11

    /* Calc 12-11 or 3-11, giving 1 or -ve (-8).  We cannot use
    'MonLate' since this routine is public and 'MonLate' may not
    have been set
    */
    ProjMonths := NewMon - OldMon + gDateAry[ 2 ] - 1

    IF ProjMonths < 0
        ProjMonths += 12  // -8 becomes +4
    ENDIF

    ProjMonths ++ // Oct 2000, one added (0 to 11 becomes 1 to 12)

    /* vnf - if you want next message remove slash-stars
        StopMsg( {                                        ;
        'weeksgap    ' + ass( weeksgap   )   ,    ;
        'NewWeek     ' + ass( NewWeek    )   ,    ;
        'NewMon      ' + ass( NewMon     )   ,    ;
        'OldMon      ' + ass( OldMon     )   ,    ;
        'ProjMonths  ' + ass( ProjMonths )   ,    ;
        } )
    */
RETURN ProjMonths




FUNCTION Bad7Msg()
    /*
    Called by ScEmerg:EditOneRec()

    Displays...
	(old screen mockup deleted)

	    Product Code XXX

	    Forecast type X
	    Monthly request flag: T/F

	    The necessary monthly data is missing or of poor quality. The
	    system's calculations will use weekly forecasting.

	    You should make a note to alter the forecast type/Monthly
	    request flag to another value for this product

		Technical reason for problem :
		xxxx
    */

    LOCAL MyCodeText, BigText

    MyCodeText := 'Product Code ' + alltrim( INPROD -> prodcode )

    BigText    := MyCodeText + "." + CRLF + CRLF              + ;
    "Forecast Type :" + ass( INPROD->fq_type )                + ;
     CRLF + CRLF                                               + ;
    "Monthly Request Flag :" + ass( INPROD->showmonth )       + ;
     CRLF + CRLF                                               + ;
    "The necessary monthly data is missing or of poor quality."+ ;
   " The system's calculations will use weekly"               + ;
   " forecasting. "                                           + ;
    CRLF + CRLF                                               + ;
   "You should make a note to alter the Forecast Type/Monthly Request Flag"+ ;
   " to another value for this product"                       + ;
    CRLF + CRLF                                               + ;
   "Technical reason for problem : " + CR + BadMonReason

    MaxMsg( BigText )
RETURN .t.





STATIC FUNCTION Lead47Msg()
    /*
    'Lead time plus 4 weeks IOT is ' +ass( LeadSave ) ' weeks.
    You need a value below 47 weeks for the monthly' ' forecast to
    work.'
    */
    DialogBox ( nil,   "emerg_11",   nil,     ;
              {       | hTestDlg, nMsg, nwParam, nlParam |   ;
              DlgFunc3( hTestDlg, nMsg, nwParam, nlParam, nil ) } )
RETURN .t.


FUNCTION StopMsg( ary, MyDlg )
    /*
    May 2001 - made public to call from BigCalc1 for testing
    */

    DEFAULT MyDlg TO "emerg_10"

    if FirstCall

        FirstCall := .f.

        CreateDialog (  nil,      MyDlg,         nil,        ;
              {       | hTestDlg, nMsg, nwParam, nlParam |   ;
              StopDlg1 ( hTestDlg, nMsg, nwParam, nlParam, ary ) } )
    else
        // dlg exists, rewrite the data
        StopDlg2 ( hDlgStat, ary )
        //////////////////  SetFocus ( hDlgStat      )
    endif

RETURN .t.


STATIC FUNCTION StopDlg1 ( hDlg, nMsg, nwParam, nlParam, ary    )
    /*
    */

    // messages dangerous here !!

    do case
        case nMsg == WM_INITDIALOG

            hDlgStat := hDlg

            StopDlg2 ( hDlg, ary    )
            RETURN 1
        case nMsg == WM_COMMAND
            do case
                case nwParam == IDOK
                    DestroyWindow( hDlg )   // used by modeless dialogs
                    FirstCall := .t.
                    RETURN 1                // means msg has been processed

                case nwParam == IDCANCEL
                    FirstCall := .t.
                    DestroyWindow( hDlg )   // used by modeless dialogs
                    RETURN 1                // means msg has been processed
            endcase
    endcase
RETURN 0

STATIC FUNCTION StopDlg2 ( hDlg, ary    )

    LOCAL LenAry := len( ary )
    LOCAL z, text

    ************** WbTone() // beep

    for z := 1 to 15 // clear text

        SetDlgItem( hDlg, 100 + z, ' '  )
    next

    for z := 1 to lenary // new text

        text := ary[z]

        SetDlgItem( hDlg, 100 + z, text )
    next
RETURN 0


STATIC FUNCTION Make12( z )//
/*
Was - converts any +ve integer to the range 1 to 12.
*/
RETURN MakeAny( z, 12 )


STATIC FUNCTION MakeAny(  z, base )
	/* 	eg			   ( 55, 52   )
   		or			   ( 13, 12   )

	Was - converts any +ve integer to the range 1 to base

	New - Jan 2008 - Handle any realistic integer number, positive,
	negative or zero. Loop to add or subtract 12 or 52. If input is zero
	or less, increment is positive. If input is positive, increment is
	negative

	Z		Output	Method
	===========================
	13		1		subtract 12

	12		12		never loops^
	to		to
	1		1		never loops^

	0		12		add 12
	to		to
	-11		1		add 12

	-12		12		add 12 twice

	^=exits at start of first loop
    */

    Local Increment

	// Glbox( '1190: z' + ass(z) )

    If z > 0
    		Increment := -1 * base
    		//
    Else // z zero or -ve
	    	//
	    	Increment := base
    Endif

	Do while .t.
		//
	    If z >= 1 .and. z <= base
	    	//
	    	Exit
	    Endif
		//
		z += Increment
	Enddo

	// Glbox( '1211: z' + ass(z) )
RETURN z



static FUNCTION Msg7Dlg( text ) // still upsets user edits
    /*
    Display modally
    */
    DialogBox ( nil,  "emerg_12",   nil,                 ;
              {       | hDlg, nMsg, nwParam, nlParam |   ;
              DlgFunc4( hDlg, nMsg, nwParam, nlParam, 'modal', text ) } )
RETURN .t.


static FUNCTION DlgFunc4 ( hDlg, nMsg, nwParam, nlParam, fModal, text )
    /*
    */
    do case
        case nMsg == WM_INITDIALOG
            //
            SetDlgItem( hDlg, 100, text )
            RETURN 1
        case nMsg == WM_COMMAND
            do case
                case nwParam == IDOK
                    EndDialog( hDlg, nwParam )
                    RETURN 1                // means msg has been processed

                case nwParam == IDCANCEL
                    EndDialog( hDlg, nwParam )
                    RETURN 1                // means msg has been processed
            endcase
    endcase
RETURN 0




STATIC FUNCTION WeeksFromDays( LeadDays ) // eg, 6 makes 1 week, 8 makes 2 weeks

    if int( LeadDays / 7 ) == LeadDays / 7    // eg, int(2.00)=14/2
        //
        RETURN LeadDays / 7
    else
        RETURN 1 + INT( LeadDays / 7 )
    endif

RETURN 0






